; This program tests whether there are duplicate values of statistics 
; when collecting 1000 images with WaitForCallbacks=1

CAM = '13SIM1:cam1:'
STATS = '13SIM1:Stats5:'
SCAN = '13SIM1:scan1'

numPoints = 1000
acquireTime = 0.005

t = caput(CAM + "WaitForPlugins", 1)
t = caput(CAM + "AcquireTime", acquireTime)
t = caput(CAM + "ImageMode", "Single")
t = caput(SCAN + ".NPTS", numPoints)
t = caput(STATS + "EnableCallbacks", "Enable")
t = caput(STATS + "TS:TSNumPoints", numPoints)
t = caput(SCAN + ".D01PV", STATS + "Net_RBV")
t = caput(SCAN + ".T1PV", CAM + "Acquire")

TS_ACQUIRE = STATS + "TS:TSAcquire"
CAPTURE = SCAN + ".EXSC"
CAPTURING = CAM + "Acquire"
SSCAN_STATE = SCAN + ".SMSG"

duplicates = 0
counter = 1
while 1 do begin

    t = caput(TS_ACQUIRE, 1)
    t = caput(CAPTURE, 1)
    wait, .1
    while 1 do begin
       t = caget(CAPTURE, v)
       if (v eq 0) then break;
    endwhile
    wait, .5
    t = caget(SCAN + ".D01CA", scanArray, max=numPoints)
    if (t ne 0) then print, "Error reading scan array status=", t
    t = caget(STATS + "TSNet", statsArray, max=numPoints)
    if (t ne 0) then print, "Error reading stats array status=", t

    b = where((scanArray - statsArray) ne 0)
    if (b ne -1) then print, 'Got mismatch', b

    print, counter
    counter += 1
endwhile
end
